=begin
Copyright 2021, Majid Mahmoudi
All Rights Reserved

Disclaimer
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

License
This software is distributed under the Smustard End User License Agreement
http://www.smustard.com/eula

Information
Author - Majid Mahmoudi
Organization - Distributed on the Extension Warehouse
Name - MAJ Window
SU Version - 21.0.339

Description
This plugin will cut walls and make door in the walls created by Maj Wall Maker.

Usage
Cut 3 layers of walls made by "Maj Group Wall Maker" and make a door with 4 clicks. First
this extension will ask you about door height, distance between bottom of the wall to
bottom of the door and the type of door.
In the first click "Finishing" and "Interior" layers will hide. You can quit this
click by clicking on "Wall" directly. In the second click, the wall will be transparent.
In this way, you can see 2D drawing under the wall if exist. In the third click, you select
the start point of the door cut. In a fourth click, you will select the length of
the door cut, and the cut will make in 3 layers and make a door on it. Also after the third click, you can
type length and press enter.

History
1.0.1:: 2021-03-16
   * Original release.  I'm expecting some bugs and feedback.
1.0.2:: 2021-03-27
   * Adding door type "Front Door #1" and "Front Door #2"
1.0.3:: 2021-04-01
   * Solving Interior Wall Cut problem
   * Cutting baseboard if touches the door.
   * Solving doorknob problem.
   * Showing information in Sketchup status text
1.0.5:: 2021-05-23
   * Status Bar always help users.
   * Arrow keys used.
   * Problems solved in MAC OS.
=end


module MajidMahmoudi

  module MajDoor            #EDIT
    require 'sketchup.rb'
    require 'extensions.rb'
    NAME = "MAJ_Door"        #EDIT
    UNAME = "MAJ Door"       #EDIT
    MENU_NAME = "MAJ Door"       #EDIT
    version = "1.0.5"           #EDIT
    desc = "This plugin will cut the wall and make a door on it."
    copy_year = "2021"
    author = "Majid Mahmoudi"

#------edit above---------------------------------------------------------------


    extension = SketchupExtension.new UNAME, NAME+"/"+NAME+"_Data"

    #The name= method sets the name which appears for an extension inside the Extensions Manager dialog.
    extension.name = UNAME

    # The description= method sets the long description which appears beneath an extension inside the Extensions Manager dialog.
    extension.description = desc + "  Access it via Plugins > "+MENU_NAME

    # The version method sets the version which appears beneath an extension inside the Extensions Manager dialog.
    extension.version = version

    # Create an entry in the Extension list that loads a script called
    # stairTools.rb.
    extension.copyright = copy_year

    # The creator= method sets the creator string which appears beneath an extension inside the Extensions Manager dialog.
    extension.creator = author

    # The register_extension method is used to register an extension with SketchUp's extension manager (in SketchUp preferences).
    Sketchup.register_extension( extension, true )

  end
end
